/* Copyright (C) 2004-2005 The SSI Project. All rights reserved.
   http://ssi.is.s.u-tokyo.ac.jp/

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.  See the LICENSE file for the precise
   terms and conditions for the use of this software.
*/

#ifndef __LIS_SOLVERS_H__
#define __LIS_SOLVERS_H__

#ifdef __cplusplus
extern "C"
{
#endif

	/****************************/
	/* SOLVER                   */
	/****************************/
		extern int lis_cg       (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_bicg     (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_MATRIX At, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_cgs      (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_bicgstab (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_bicgstabl(LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_gpbicg   (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_gmres    (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_orthomin (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_qmr      (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_jacobi   (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_gs       (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);
		extern int lis_sor      (LIS_VECTOR b, LIS_VECTOR x, LIS_VECTOR work[], LIS_SCALAR params[], int options[], LIS_MATRIX A, LIS_PRECON M, LIS_SCALAR status[]);

	extern int lis_get_initial_residual(LIS_MATRIX A, LIS_PRECON M, LIS_VECTOR x, LIS_VECTOR b, LIS_VECTOR r, LIS_VECTOR t, LIS_SCALAR tol, LIS_SCALAR *bnrm2, LIS_SCALAR status[]);
	extern void lis_set_residual_history(LIS_SCALAR res);

#ifdef __cplusplus
}
#endif
#endif
