/* Copyright (C) 2004-2005 The SSI Project. All rights reserved.
   http://ssi.is.s.u-tokyo.ac.jp/

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.  See the LICENSE file for the precise
   terms and conditions for the use of this software.
*/

#ifndef __LISLIB_H__
#define __LISLIB_H__

#define HAVE_CONFIG_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "lis.h"
#include "lis_matrix.h"
#include "lis_matvec.h"
#include "lis_precon.h"
#include "lis_solver.h"
#include "lis_io.h"

#ifdef USE_MPI
#define LIS_IF(s)										\
	err1 = 0;											\
	if( s )												\
	{													\
		err1 = 1;										\
	}													\
	MPI_Allreduce(&err1,&err2,1,MPI_INT,MPI_SUM,comm);	\
	if(err2)
#else
#define LIS_IF(s)	if( s )
#endif
#endif
