MODULE struc_symmetrize_mod
CONTAINS
  
  !C output form: N,NP,IN{U,L},IA{U,L},A{U,L},{STACK,NOD}_{IMPORT,EXPORT}
  !C input form : *_i
  SUBROUTINE struc_symmetrize                                             &
       & ( N_i, NP_i, INU_i, INL_i, IAU_i, IAL_i, AU_i, AL_i,             &
       &   STACK_IMPORT_i, STACK_EXPORT_i, NOD_IMPORT_i, NOD_EXPORT_i,    &
       &   NEIBPE_i, NEIBPETOT_i, N, NP, INU, INL, IAU, IAL, AU, AL,      &
       &   STACK_IMPORT, STACK_EXPORT, NOD_IMPORT, NOD_EXPORT, NEIBPE,    &
       &   NEIBPETOT, SOLVER_COMM, my_rank, PETOT)
    USE count_time_mod
    IMPLICIT none
    INCLUDE 'precision.inc'
    integer(kind=kint ), intent(in) :: SOLVER_COMM, my_rank, PETOT
    !C-- ordering 
    integer(kind=kint ), pointer :: order_i(:), order_o(:)

    
    !C-- initial distributed matrix form
    integer(kind=kint) :: N_i, NP_i, NEIBPETOT_i
    real   (kind=KREAL), pointer :: D_i(:), B_i(:)
    integer(kind=kint ), pointer :: INU_i(:), INL_i(:)
    integer(kind=kint ), pointer :: IAU_i(:), IAL_i(:)
    real   (kind=KREAL), pointer :: AU_i(:), AL_i(:)
    integer(kind=kint ), pointer :: NOD_IMPORT_i(:)
    integer(kind=kint ), pointer :: NOD_EXPORT_i(:)
    integer(kind=kint ), pointer :: NEIBPE_i(:)
    integer(kind=kint ), pointer :: STACK_IMPORT_i(:)
    integer(kind=kint ), pointer :: STACK_EXPORT_i(:)
    
    !C-- redistributed matrix form
    integer(kind=kint) :: N, NP, NEIBPETOT
    real   (kind=KREAL),  pointer :: D(:), B(:)
    integer(kind=kint ),  pointer :: INU(:), INL(:)
    integer(kind=kint ),  pointer :: IAU(:), IAL(:)
    real   (kind=KREAL),  pointer :: AU(:), AL(:)
    integer(kind=kint ),  pointer :: NOD_IMPORT(:)
    integer(kind=kint ),  pointer :: NOD_EXPORT(:)
    integer(kind=kint ),  pointer :: NEIBPE(:)
    integer(kind=kint ),  pointer :: STACK_IMPORT(:)
    integer(kind=kint ),  pointer :: STACK_EXPORT(:)
    
    !C-- index arrays for parmetis
    integer(kind=kint ), pointer :: vtxdist(:), xadj(:)
    integer(kind=kint ), pointer :: vwgt(:), adjwgt(:)
    integer(kind=kint ), pointer :: adjncy(:), part(:)
    integer(kind=kint ) :: wgtflag, numflag, options(0:2), edgecut
    integer(kind=kint ) :: ncon, nparts
    REAL   (kind=kfloat):: ubvec
    REAL   (kind=kfloat), allocatable :: tpwgts(:)
    
    !C-- global number vector for parmetis
    integer(kind=kint ), pointer :: global_number_vector(:)
    
    integer(kind=kint ) :: i, j, k

    integer(kind=kint ), allocatable :: dist_nodes(:), new_part(:)

    CHARACTER(len= 4 ) :: penum

  END SUBROUTINE struc_symmetrize

END MODULE  struc_symmetrize_mod
