!C   Copyright (C) 2004-2005 The SSI Project. All rights reserved.
!C   http://ssi.is.s.u-tokyo.ac.jp/
!C
!C   This software is distributed in the hope that it will be useful,
!C   but WITHOUT ANY WARRANTY.  See the LICENSE file for the precise
!C   terms and conditions for the use of this software.

module isort
contains
  subroutine  qsorti(ord,N,A)
    implicit none
    include 'precision.inc'
    integer(kind=kint) :: N
    integer(kind=kint),DIMENSION(N) ::ORD
    integer(kind=kint),DIMENSION(N) ::A

    integer(kind=kint) :: i
    DO i=1,N
       ord(i)=i
    END DO
    call qsort_rec(ord,N,A,1,N)
    contains

      recursive subroutine qsort_rec(ord,N,A,l,h)
        implicit none
        include 'precision.inc'
        integer(kind=kint) :: N,l,h
        integer(kind=kint),DIMENSION(N) ::ORD
        integer(kind=kint),DIMENSION(N) ::A

        integer(kind=kint) :: ii,jj,i,j,k,p,temp,t

        if(l>=h) return

        p=(l+h)/2
        temp=ord(p);ord(p)=ord(l);ord(l)=temp;
        t=A(temp);i=l;j=h;

        DO
           DO ii=i+1,h
              k=ord(ii)
              if(A(k)>=t) exit
           END DO
           i=ii
           DO jj=j,l+1,-1
              k=ord(jj)
              if(A(k)<t) exit
           END DO
           j=jj

           if(i>j) exit
           temp=ord(i);ord(i)=ord(j);ord(j)=temp;
        END DO
        temp=ord(l);ord(l)=ord(j);ord(j)=temp;

        call qsort_rec(ord,N,A,l,j-1)
        call qsort_rec(ord,N,A,j+1,h)
      end subroutine qsort_rec
      
  end subroutine qsorti
end module isort









